var game;
var speedMult = 0.7;
var friction = 0.99;
var colors = ["0xac81bd","0xff5050","0xdab5ff","0xb5ffda","0xfffdd0","0xcc0000","0x54748b","0x4b0082","0x80ab2f","0xff784e","0xe500db","0x223c4a","0x223c4a","0xf1290e","0x648080","0xbbc1c4","0x6f98a2","0x71717e"];


window.onload = function() {	
	game = new Phaser.Game(500,889, Phaser.AUTO, "");
     game.state.add("PlayGame", playGame);
     game.state.start("PlayGame");
}

var playGame = function(game){};
playGame.prototype = {
     preload: function(){

          game.load.image("background","asset/bkg/black_bkg.png");


          game.load.image("avatar0", "asset/hud/transp.png");
          game.load.image("avatar1", "asset/ships/6.png");
          game.load.image("avatar2", "asset/ships/2.png");
          game.load.image("avatar3", "asset/ships/3.png");
          game.load.image("avatar4", "asset/ships/11.png");
          game.load.image("avatar5", "asset/ships/12.png");
          game.load.image("avatar6", "asset/ships/13.png");
          game.load.image("avatar7", "asset/ships/14.png");

          game.load.image("button", "asset/hud/ball.png");
          game.load.image("transp", "asset/hud/transp.png");
     },
     create: function(){  



	// showing the game in full screen
	game.scale.pageAlignHorizontally = true;
	game.scale.pageAlignVertically = true;
	game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
	game.scale.setScreenSize();

	background=game.add.sprite(0,0,"background");
	game.physics.enable(background, Phaser.Physics.ARCADE);
	background.body.immovable = true;
	game.add.text(game.width / 2, 50, "Select your ship", {font: "18px Arial", fill: "#ffffff"}).anchor.set(0.5);
	
	this.scrollingMap = game.add.tileSprite(0, 0, game.width / 2 + 8 * 140 + 114, game.height, "transp");
	this.scrollingMap.inputEnabled = true;
	this.scrollingMap.input.enableDrag(false);
	this.scrollingMap.savedPosition = new Phaser.Point(this.scrollingMap.x, this.scrollingMap.y);
	this.scrollingMap.isBeingDragged = false; 
	this.scrollingMap.movingSpeed = 0; 
	this.scrollingMap.input.allowVerticalDrag = false;
	this.scrollingMap.input.boundsRect = new Phaser.Rectangle(game.width - this.scrollingMap.width, game.height - this.scrollingMap.height, this.scrollingMap.width * 2 - game.width, this.scrollingMap.height * 2 - game.height);

	for(var i = 0; i <= 7; i++){
		var partialname="avatar"+i;

		var myDummy = game.add.image(game.width / 2 + i * 140, game.height / 2, partialname);
		myDummy.anchor.set(0.5);

		this.scrollingMap.addChild(myDummy)
	}
	this.scrollingMap.events.onDragStart.add(function(){
	   this.scrollingMap.isBeingDragged = true;
	   this.scrollingMap.movingSpeed = 0;
	}, this);
	this.scrollingMap.events.onDragStop.add(function(){
	   this.scrollingMap.isBeingDragged = false;
	}, this);

	this.styleName = {font: '50px Arial', fill: '#eeeeec', align: 'left', fontWeight: 'bold', stroke: '#8f5902', strokeThickness: 9};
	this.dummyName = game.add.text(this.world.centerX, 100, 'Choose a ship', this.styleName);

	this.dummyName.anchor.set(0.5);

	this.choosenDummy='';

	this.buttonF = this.add.button(this.world.centerX, 600,  'button', function () {

		if(this.choosenDummy>=1){  
			localStorage["character"] = this.choosenDummy-1;
			window.open('index.html','_self');

		}
		
	    }, this);

	this.buttonF.anchor.set(0.5);
	this.buttonF.cameraOffset.x = this.world.centerX;
	this.buttonF.cameraOffset.y = 600;


     },
     update:function(){
          var zoomed = false;
          for(var i = 0; i < this.scrollingMap.children.length; i++){
               if(Math.abs(this.scrollingMap.children[i].world.x - game.width / 2) < 46 && !zoomed){
                    //this.scrollingMap.getChildAt(i).scale.setTo(1.5);
                    this.scrollingMap.getChildAt(i).scale.setTo(4);
                    zoomed = true;
			console.log(i);
			this.dummyName.text = "SHIP N."+i;
			this.choosenDummy=i;
			console.log('choosenDummy: '+this.choosenDummy);
               }
               else{
                    this.scrollingMap.getChildAt(i).scale.setTo(1);   
               }
          }
          if(this.scrollingMap.isBeingDragged){
               this.scrollingMap.savedPosition = new Phaser.Point(this.scrollingMap.x, this.scrollingMap.y);
          }
          else{
               if(this.scrollingMap.movingSpeed > 1){
                    this.scrollingMap.x += this.scrollingMap.movingSpeed * Math.cos(this.scrollingMap.movingangle);
                    if(this.scrollingMap.x < game.width - this.scrollingMap.width){
                         this.scrollingMap.x = game.width - this.scrollingMap.width;
                         this.scrollingMap.movingSpeed *= 0.5;
                         this.scrollingMap.movingangle += Math.PI;
                         
                    }
                    if(this.scrollingMap.x > 0){
                         this.scrollingMap.x = 0;
                         this.scrollingMap.movingSpeed *= 0.5;
                         this.scrollingMap.movingangle += Math.PI;
                    }
                    this.scrollingMap.movingSpeed *= friction;
                    this.scrollingMap.savedPosition = new Phaser.Point(this.scrollingMap.x, this.scrollingMap.y);
               }
               else{
                    var distance = this.scrollingMap.savedPosition.distance(this.scrollingMap.position);
                    var angle = this.scrollingMap.savedPosition.angle(this.scrollingMap.position);
                    if(distance > 4){
                         this.scrollingMap.movingSpeed = distance * speedMult;
                         this.scrollingMap.movingangle = angle;
                    }
               }
          }
     }
}
